// 012 u_test_u_handle_files_in_dirs
// 03 jan 2002

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)
unit u_test_u_handle_files_in_dirs;
  interface
    uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
      Dialogs, StdCtrls;

    type TForm1 = class(TForm)
                    Memo1: TMemo;
    list_names_: TButton;
    dir_: TEdit;
    sizes_: TButton;
                    procedure FormCreate(Sender: TObject);
    procedure list_names_Click(Sender: TObject);
    procedure sizes_Click(Sender: TObject);
                    private
                    public
                  end;

    var Form1: TForm1;

  implementation
    uses u_c_log, u_c_display, u_strings
      , u_handle_files_in_dirs;

    {$R *.DFM}

  
    const k_log_path= 'log\';
          k_log_name= 'log_handle_files_in_dirs.txt';

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_display_log(k_log_path+ k_log_name);
      end; // FormCreate

    // -- test the unit

    procedure display_file_name_call_back(p_level: Integer; p_dir, p_file_name: String;
          p_pt_data: Pointer);
      begin
        display(f_spaces(2* p_level)+ p_file_name);
      end; // display_file_name_call_back

    procedure TForm1.list_names_Click(Sender: TObject);
      var l_path, l_extension: String;
      begin
        l_path:= dir_.Text;
        l_extension:= '.PAS';

        handle_all_files_recursive(1, l_path, l_extension,
            [e_dir_recursive, e_dir_handle_file], display_file_name_call_back, Nil);
      end; // list_names_Click

    // -- compute the sizes

    type t_pt_size= pInteger;

    procedure add_file_size_call_back(p_level: Integer; p_dir, p_file_name: String;
          p_pt_data: Pointer);
      var l_file: File;
      begin
        Assign(l_file, p_dir+ p_file_name);
        Reset(l_file, 1);

        Inc(t_pt_size(p_pt_data)^, FileSize(l_file));

        Close(l_file);
      end; // add_file_size_call_back

    procedure TForm1.sizes_Click(Sender: TObject);
      var l_path, l_extension: String;
          l_total_size: Integer;
      begin
        l_path:= dir_.Text;
        l_extension:= '.PAS';

        handle_all_files_recursive(1, l_path, l_extension,
            [e_dir_recursive, e_dir_handle_file], add_file_size_call_back, @ l_total_size);

        display('Total size: '+ IntToStr(l_total_size)+ ' bytes');    
      end;

end.


